=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2011-06-27 14:43:56 +0000
+++ loggerhead/controllers/__init__.py	2011-06-27 15:05:06 +0000
@@ -54,6 +54,7 @@
 class TemplatedBranchView(object):
 
     template_path = None
+    supports_json = False
 
     def __init__(self, branch, history_callable):
         self._branch = branch
@@ -87,6 +88,9 @@
 
     def __call__(self, environ, start_response):
         z = time.time()
+        if environ.get('loggerhead.as_json') and not self.supports_json:
+            raise HTTPNotFound
+
         path = self.parse_args(environ)
         headers = {}
         values = self.get_values(path, self.kwargs, headers)

=== modified file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2011-06-27 14:37:04 +0000
+++ loggerhead/controllers/filediff_ui.py	2011-06-27 15:05:06 +0000
@@ -77,6 +77,7 @@
 class FileDiffUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.filediff'
+    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         revid = urllib.unquote(self.args[0])

=== modified file 'loggerhead/controllers/revlog_ui.py'
--- loggerhead/controllers/revlog_ui.py	2011-06-27 14:37:04 +0000
+++ loggerhead/controllers/revlog_ui.py	2011-06-27 15:05:06 +0000
@@ -6,6 +6,7 @@
 class RevLogUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revlog'
+    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         history = self._history

